/**
 * Javier Abelln. 6 Abril 2006
 * 
 * Librera grfica
 */


package chuidiang.graficos;

import java.awt.geom.Rectangle2D;



/**
 * Clase encargada de transformar coordenadas de usuario en pixels y viceversa
 * en grficos con coordenadas polares.<br>
 *
 */
public class EscalaGraficaPolar2 extends EscalaGraficaPolar
{
	/**
	 * Devuelve los extremos polares del dibujo.
	 */
	public Rectangle2D dameExtremos() {
		Rectangle2D.Double resultado = new Rectangle2D.Double();
		Rectangle2D cartesianos = this.getExtremosCartesianos();
		if ((cartesianos.getX()<0) && 
				((cartesianos.getX()+cartesianos.getWidth())>0) &&
				(cartesianos.getY()<0) &&
				((cartesianos.getY()+cartesianos.getHeight()>0)))
		{
			// El centro est dentro del grfico
			resultado.x=0.0;
			resultado.width=Math.max(cartesianos.getWidth(),cartesianos.getHeight());
			resultado.y=0.0;
			resultado.height=2.0*Math.PI;
		}
		else
		{
			// Esta fuera
			double min = Math.abs(cartesianos.getX());
			min = Math.min(min, Math.abs(cartesianos.getX()+cartesianos.getWidth()));
			min = Math.min(min, Math.abs(cartesianos.getY()));
			min = Math.min(min, Math.abs(cartesianos.getY()+cartesianos.getHeight()));
			double max = Math.abs(cartesianos.getX());
			max = Math.max(max, Math.abs(cartesianos.getX()+cartesianos.getWidth()));
			max = Math.max(max, Math.abs(cartesianos.getY()));
			max = Math.max(max, Math.abs(cartesianos.getY()+cartesianos.getHeight()));
			resultado.x=0.0;
			resultado.width=max-min;
			resultado.y=0.0;
			resultado.height=2*0*Math.PI;
		}
		return resultado;
	}
	
}
