/**
 * Javier Abelln. 6 Abril 2006
 * 
 * Librera grfica
 */


package chuidiang.graficos;


import java.awt.geom.Rectangle2D;

import chuidiang.matematicas.UtilRectangulo;


/**
 * Realiza zoom de escalas graficas cartesianas.<br>
 *
 */
public class ZoomEscalaGraficaCartesiana
        implements InterfaceZoomable
{
   //~ Variables de instancia --------------------------------------------------

   /** La escala grafica cartesiana sobre la que hara zoom.*/
   private EscalaGraficaCartesiana escala;

   //~ Constructores -----------------------------------------------------------

   /**
    * Crea  un nuevo objeto de la clase ZoomEscalaGraficaCartesiana.<br>
    *
    * @param escala La escala sobre la que debe hacer zoom.<br>
    */
   public ZoomEscalaGraficaCartesiana( EscalaGraficaCartesiana escala )
   {
      this.escala = escala;
   }

   //~ Metodos -----------------------------------------------------------------

   /**
    * Acerca el grfico en el porcentaje que se le indica.<br>
    *
    * @param porcentaje Porcentaje en %.<br>
    */
   public void acercar( double porcentaje )
   {
      Rectangle2D extremos = escala.dameExtremos(  );

      Rectangle2D nuevo = UtilRectangulo.agrandar( 
            extremos,
            porcentaje );
      escala.tomaExtremos( 
         nuevo.getMinX(  ),
         nuevo.getMinY(  ),
         nuevo.getMinX(  ) + nuevo.getWidth(  ),
         nuevo.getMinY(  ) + nuevo.getHeight(  ) );
   }

   /**
    * Aleja el grfico en el porcentaje en % que se le indica.<br>
    *
    * @param porcentaje Porcentaje en %.<br>
    */
   public void alejar( double porcentaje )
   {
      acercar( -porcentaje );
   }

   /**
    * Desplaza el grfico de forma que un punto dado quede en una nueva posicin
    *
    * @param viejaX x del punto.<br>
    * @param viejaY y del punto.<br>
    * @param nuevaX nueva x que se desea para el punto.<br>
    * @param nuevaY nueva y que se desea para el punto.<br>
    */
   public void desplazar( 
      double viejaX,
      double viejaY,
      double nuevaX,
      double nuevaY )
   {
      Rectangle2D extremos = escala.dameExtremos(  );

      escala.tomaExtremos( 
         extremos.getMinX(  ) - ( nuevaX - viejaX ),
         extremos.getMinY(  ) - ( nuevaY - viejaY ),
         ( extremos.getMinX(  ) + extremos.getWidth(  ) ) - ( nuevaX - viejaX ),
         ( extremos.getMinY(  ) + extremos.getHeight(  ) ) - ( nuevaY - viejaY ) );
   }
}
